from django.conf import settings
from django.db import models
from django.contrib.auth.models import User

class Comment(models.Model):
	text = models.TextField(verbose_name=_('Text'))
	date = models.DateTimeField(auto_now_add = True)
	apptype = models.PositiveSmallIntegerField()
	appid = models.PositiveIntegerField()
	author = models.ForeignKey(User)
	ip = models.CharField(maxlength=20, blank=True)
	class Meta:
		verbose_name = _('Comment')
		verbose_name_plural = _('Comments')
		db_table = 'rk_com' + str(settings.SITE_ID)
	def __str__(self):
		if self.apptype == 1:
			from pages.models import Page
			a = Page.objects.values('title').get(id = self.appid)
			a = a['title']
		elif self.apptype == 2:
			from news.models import News
			a = News.objects.values('title').get(id = self.appid)
			a = a['title']
		elif self.apptype == 3:
			from tasks.models import Task
			a = Task.objects.values('name').get(id = self.appid)
			a = a['name']
		elif self.apptype == 4:
			from translator.models import Translation
			a = Translation.objects.values('name').get(id = self.appid)
			a = a['name']
		elif self.apptype == 5:
			from baldur.models import Character
			a = Character.objects.values('name').get(id = self.appid)
			a = a['name']
		else:
			a = _('Comment')
		return str(a)