from django.shortcuts import render_to_response
from boxcomments.models import *
from django.template import RequestContext
from django.contrib.sites.models import Site
from django.http import HttpResponseRedirect, HttpResponse

def comments(request, apptype, appid):
	com = Comment.objects.filter(apptype= apptype, appid = appid).order_by('-id')
	if apptype == '1':
		from pages.models import Page
		a = Page.objects.get(id = appid)
	elif apptype == '2':
		from news.models import News
		a = News.objects.get(id = appid)
	elif apptype == '3':
		from tasks.models import Task
		a = Task.objects.get(id = appid)
	elif apptype == '4':
		from translator.models import Translation
		a = Translation.objects.get(id = appid)
	elif apptype == '5':
		from baldur.models import Character
		a = Character.objects.get(id = appid)
	if request.user.is_authenticated():
		staff = request.user.is_staff
	else:
		staff = False
	from stripogram import html2safehtml
	if request.user.is_authenticated():
		if request.POST and len(request.POST['text']) > 0:
			text = html2safehtml(request.POST['text'] ,valid_tags=('b', 'a', 'i', 'br', 'p', 'u', 'pre', 'div', 'span', 'img', 'li', 'ul', 'ol', 'center', 'sub', 'sup', 'blockquote'))
			co = Comment(appid = appid, text = text, author = request.user, ip = request.META['REMOTE_ADDR'], apptype = apptype)
			co.save()
			from django.core.mail import mail_admins
			s = Site.objects.get(id=settings.SITE_ID)
			mail_admins('Komentarz Dodany', 'Dodano komentarz: http://www.' + str(s), fail_silently=True)
			return HttpResponseRedirect('/com/' + str(appid) + '/' + str(apptype) + '/')
		else:
			return render_to_response('boxcomments/comments.html', {'com': com, 'staff': staff, 'appid': appid, 'apptype': apptype, 'a': a}, context_instance=RequestContext(request))
	else:
		return render_to_response('boxcomments/comments.html', {'com': com, 'anon': True, 'staff': staff, 'appid': appid, 'apptype': apptype, 'a': a}, context_instance=RequestContext(request))
