from django.shortcuts import render_to_response
from boxcomments.models import Comment
from news.models import *
from django.template import RequestContext
from django.contrib.sites.models import Site

def show(request, slug):
	try:
		object = News.objects.get(slug=slug)
	except:
		return render_to_response('pages/bug.html', {'bug': _('There is no news with this ID')}, context_instance=RequestContext(request))
	com = Comment.objects.filter(apptype= 2, appid = object.id).count()
	if request.user.is_authenticated():
		staff = request.user.is_staff
	else:
		staff = False
	return render_to_response('news/news_show.html', {'com': com, 'object': object, 'staff': staff, 'domain': str(Site.objects.get_current()).replace('www.', '').replace('http://', '')}, context_instance=RequestContext(request))

def category_list(request):
	cat = Category.objects.all()
	return render_to_response('news/cat_list.html', {'cat': cat}, context_instance=RequestContext(request))

def category_news_list(request, cid, pagination_id=1):
	news  = Category.objects.get(id=cid).news_set.all().order_by('-id')
	from django.views.generic.list_detail import object_list
	return object_list(request, news, paginate_by = 10, page = pagination_id, extra_context = {'domain': str(Site.objects.get_current()).replace('www.', '').replace('http://', ''), 'cid': cid}, template_name = 'news/cat_news_list.html')

def category_news_rss(request, cid, no_external=False):
	if no_external:
		news  = Category.objects.get(id=cid).news_set.filter(is_external=False).order_by('-id')
	else:
		news  = Category.objects.get(id=cid).news_set.all().order_by('-id')
	return render_to_response('pages/rss2.html', {'news': news, 'domain': str(Site.objects.get_current()).replace('www.', '').replace('http://', '')}, context_instance=RequestContext(request))