from django.conf import settings
from django.db import models
from pages.models import Page

class Task(models.Model):
	page =  models.ForeignKey(Page, verbose_name=_('Related Page'), blank=True)
	name = models.CharField(maxlength=255, verbose_name=_('Task Title'))
	text = models.TextField(verbose_name=_('Task Description'))
	status = models.BooleanField(default=True, verbose_name=_('Task Opened'))
	creation_date = models.DateTimeField(auto_now_add = True, verbose_name=_('Creation Date'), blank=True)
	modification_date = models.DateTimeField(auto_now = True, verbose_name=_('Modification Date'), blank=True)
	author = models.CharField(maxlength=255, verbose_name=_('Author'), blank=True)
	class Meta:
		verbose_name = _('Task')
		verbose_name_plural = _('Site Tasks')
		db_table = 'rk_task' + str(settings.SITE_ID)
	class Admin:
		list_display = ('name', 'status')
		search_fields = ['name', 'text']
	def get_absolute_url(self):
		return '/tasks/show/' + str(self.id) + '/'
	def __str__(self):
		return self.name
